## ghc 7.4.1

=== Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

ifeq "$(wildcard distrib/)" ""

# We're in a bindist

.PHONY: default
default:
	@echo 'Run "make install" to install'
	@false

.PHONY: install show
install show:
	$(MAKE) -r --no-print-directory -f ghc.mk $@ BINDIST=YES NO_INCLUDE_DEPS=YES

else

default : all
	@:

# For help, type 'make help'
.PHONY: help
help :
	@cat MAKEHELP

ifneq "$(findstring clean,$(MAKECMDGOALS))" ""
-include mk/config.mk
else
include mk/config.mk
ifeq "$(ProjectVersion)" ""
$(error Please run ./configure first)
endif
endif

include mk/custom-settings.mk

# No need to update makefiles for these targets:
REALGOALS=$(filter-out binary-dist binary-dist-prep bootstrapping-files framework-pkg clean clean_% distclean maintainer-clean show help test fulltest,$(MAKECMDGOALS))

# configure touches certain files even if they haven't changed.  This
# can mean a lot of unnecessary recompilation after a re-configure, so
# here we cache the old versions of these files so we can restore the
# timestamps.
%.old:  %
	@set -x && test -f $@ && cmp -s $< $@ || cp -p $< $@
	touch -r $@ $<


# NB. not the same as saying '%: ...', which doesn't do the right thing:
# it does nothing if we specify a target that already exists.
.PHONY: $(REALGOALS)
$(REALGOALS) all: mk/config.mk.old mk/project.mk.old compiler/ghc.cabal.old
ifneq "$(OMIT_PHASE_0)" "YES"
	@echo "===--- building phase 0"
	$(MAKE) -r --no-print-directory -f ghc.mk phase=0 phase_0_builds
endif
ifneq "$(OMIT_PHASE_1)" "YES"
	@echo "===--- building phase 1"
	$(MAKE) -r --no-print-directory -f ghc.mk phase=1 phase_1_builds
endif
	@echo "===--- building final phase"
	$(MAKE) -r --no-print-directory -f ghc.mk phase=final $@

binary-dist: binary-dist-prep
ifeq "$(mingw32_TARGET_OS)" "1"
	mv bindistprep/*.exe .
endif
	mv bindistprep/*.tar.bz2 .

binary-dist-prep:
ifeq "$(mingw32_TARGET_OS)" "1"
	$(MAKE) -r --no-print-directory -f ghc.mk windows-binary-dist-prep
	$(MAKE) -r --no-print-directory -f ghc.mk windows-installer
else
	rm -f bindist-list
	$(MAKE) -r --no-print-directory -f ghc.mk bindist BINDIST=YES
	$(MAKE) -r --no-print-directory -f ghc.mk unix-binary-dist-prep
endif

clean distclean maintainer-clean:
	$(MAKE) -r --no-print-directory -f ghc.mk $@ CLEANING=YES
	test ! -d testsuite || $(MAKE) -C testsuite $@

$(filter clean_%, $(MAKECMDGOALS)) : clean_% :
	$(MAKE) -r --no-print-directory -f ghc.mk $@ CLEANING=YES

bootstrapping-files show:
	$(MAKE) -r --no-print-directory -f ghc.mk $@

ifeq "$(darwin_TARGET_OS)" "1"
framework-pkg:
	$(MAKE) -C distrib/MacOS $@
endif

# If the user says 'make A B', then we don't want to invoke two
# instances of the rule above in parallel:
.NOTPARALLEL:

endif

.PHONY: test
test:
	$(MAKE) -C testsuite/tests CLEANUP=1 OUTPUT_SUMMARY=../../testsuite_summary.txt fast

.PHONY: fulltest
fulltest:
	$(MAKE) -C testsuite/tests CLEANUP=1 OUTPUT_SUMMARY=../../testsuite_summary.txt

=== bindisttest/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

.PHONY: default_target

default_target: all

# Ideally we'd just include something to give us variables
# for paths and arguments to tools etc, and those set in mk/build.mk.
TOP=..
include $(TOP)/mk/tree.mk
include $(TOP)/mk/config.mk

ifeq "$(TEST_PREP)" "YES"
BIN_DIST_TEST_TAR_BZ2 = ../$(BIN_DIST_PREP_TAR_BZ2)
else
BIN_DIST_TEST_TAR_BZ2 = ../$(BIN_DIST_TAR_BZ2)
endif

all:
	"$(RM)" $(RM_OPTS_REC) $(BIN_DIST_INST_SUBDIR)
	"$(RM)" $(RM_OPTS_REC) a/b/c/*
	"$(RM)" $(RM_OPTS) HelloWorld HelloWorld.o HelloWorld.hi output
# We use the a/b/c subdirectory as configure looks for install-sh in
# . .. ../.. and we don't want it to find the build system's install-sh.
#
# NB. tar has funny interpretation of filenames sometimes (thinking
# c:/foo is a remote file), so it's safer to bzip and then pipe into
# tar rather than using tar -xjf:
	cd a/b/c/ && $(BZIP2_CMD) -cd ../../../$(BIN_DIST_TEST_TAR_BZ2) | $(TAR_CMD) -xf -
ifeq "$(Windows)" "YES"
	mv a/b/c/$(BIN_DIST_NAME) $(BIN_DIST_INST_DIR)
else
	cd a/b/c/$(BIN_DIST_NAME) && ./configure --prefix=$(BIN_DIST_INST_DIR)
	cd a/b/c/$(BIN_DIST_NAME) && $(MAKE) install
endif
	$(BIN_DIST_INST_DIR)/bin/runghc HelloWorld > output
	$(CONTEXT_DIFF) output expected_output
	$(BIN_DIST_INST_DIR)/bin/ghc --make HelloWorld
	./HelloWorld > output
	$(CONTEXT_DIFF) output expected_output
# Without --no-user-package-conf we might pick up random packages from ~/.ghc
	$(BIN_DIST_INST_DIR)/bin/ghc-pkg check --no-user-package-conf

clean distclean:
	"$(RM)" $(RM_OPTS_REC) $(BIN_DIST_INST_SUBDIR)
	"$(RM)" $(RM_OPTS_REC) a/b/c/*
	"$(RM)" $(RM_OPTS) HelloWorld HelloWorld.o HelloWorld.hi output

# Ignore a load of other standard targets
install install-docs doc:
	@:

show:
	@echo '$(VALUE)="$($(VALUE))"'

=== compiler/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

# If the user says 'make' or 'make stage=2' here, we behave as if they were
# in the ghc directory instead, so that the executable GHC gets built.
.PHONY: default_to_ghc all_ghc
default_to_ghc : all_ghc

dir = compiler

include ../mk/compiler-ghc.mk

all_ghc :
	+$(TOPMAKE) all_ghc $(EXTRA_MAKE_OPTS)

=== docs/docbook-cheat-sheet/Makefile ===
TOP = ../..
include $(TOP)/mk/boilerplate.mk

XML_DOC = docbook-cheat-sheet
INSTALL_XML_DOC = docbook-cheat-sheet

include $(TOP)/mk/bindist.mk

include $(TOP)/mk/target.mk

=== driver/split/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = driver/split
TOP = ../..
include $(TOP)/mk/sub-makefile.mk

=== utils/ltx/Makefile ===
TOP=../..
include $(TOP)/mk/boilerplate.mk

SCRIPT_PROG=ltx
SCRIPT_OBJS=ltx.prl
SCRIPT_SUBST_VARS=DEFAULT_TMPDIR CONTEXT_DIFF

INTERP=perl
DESTDIR=$(INSTSCRIPTDIR)
CLEAN_FILES += $(SCRIPT_PROG)

include $(TOP)/mk/target.mk

=== libraries/Cabal/Cabal/Makefile ===

VERSION=1.13.3

#KIND=devel
KIND=rc
#KIND=cabal-latest

PREFIX=/usr/local
HC=ghc
GHCFLAGS=-Wall

all: build

# build the library itself

SOURCES=Distribution/*.hs Distribution/Simple/*.hs Distribution/PackageDescription/*.hs Distribution/Simple/GHC/*.hs Distribution/Simple/Build/*.hs Distribution/Compat/*.hs Distribution/Simple/Program/*.hs
CONFIG_STAMP=dist/setup-config
BUILD_STAMP=dist/build/libHSCabal-$(VERSION).a
HADDOCK_STAMP=dist/doc/html/Cabal/index.html
USERGUIDE_STAMP=dist/doc/users-guide/index.html
SDIST_STAMP=dist/Cabal-$(VERSION).tar.gz
DISTLOC=dist/release
DIST_STAMP=$(DISTLOC)/Cabal-$(VERSION).tar.gz

COMMA=,

setup: $(SOURCES) Setup.hs
	-mkdir -p dist/setup
	$(HC) $(GHCFLAGS) --make -i. -odir dist/setup -hidir dist/setup Setup.hs -o setup

Setup-nhc:
	hmake -nhc98 -package base -prelude Setup

$(CONFIG_STAMP): setup Cabal.cabal
	./setup configure --with-compiler=$(HC) --prefix=$(PREFIX)

build: $(BUILD_STAMP)
$(BUILD_STAMP): $(CONFIG_STAMP) $(SOURCES)
	./setup build

install: $(BUILD_STAMP)
	./setup install

hugsbootstrap:
	rm -rf dist/tmp dist/hugs
	mkdir -p dist/tmp
	mkdir dist/hugs
	cp -r Distribution dist/tmp
	hugs-package dist/tmp dist/hugs
	cp Setup.lhs Cabal.cabal dist/hugs

hugsinstall: hugsbootstrap
	cd dist/hugs && ./Setup.lhs configure --hugs
	cd dist/hugs && ./Setup.lhs build
	cd dist/hugs && ./Setup.lhs install

# documentation...

haddock: $(HADDOCK_STAMP)
$(HADDOCK_STAMP) : $(CONFIG_STAMP) $(BUILD_STAMP)
	./setup haddock

PANDOC=pandoc
PANDOC_OPTIONS= \
	--standalone \
	--smart \
	--css=$(PANDOC_HTML_CSS)
PANDOC_HTML_OUTDIR=dist/doc/users-guide
PANDOC_HTML_CSS=Cabal.css

users-guide: $(USERGUIDE_STAMP) doc/*.markdown
$(USERGUIDE_STAMP): doc/*.markdown
	mkdir -p $(PANDOC_HTML_OUTDIR)
	for file in $^; do $(PANDOC) $(PANDOC_OPTIONS) --from=markdown --to=html --output $(PANDOC_HTML_OUTDIR)/$$(basename $${file} .markdown).html $${file}; done
	cp doc/$(PANDOC_HTML_CSS) $(PANDOC_HTML_OUTDIR)

docs: haddock users-guide

clean:
	rm -rf dist/
	rm -f setup

# testing...

moduleTest: tests/ModuleTest.hs tests/PackageDescriptionTests.hs
	mkdir -p dist/test
	$(HC) --make -Wall -DDEBUG -odir dist/test -hidir dist/test \
		-itests tests/ModuleTest.hs -o moduleTest

#tests: moduleTest clean
#	cd tests/A && $(MAKE) clean
#	cd tests/HUnit-1.0 && $(MAKE) clean
#	cd tests/A && $(MAKE)
#	cd tests/HUnit-1.0 && $(MAKE)

#check:
#	rm -f moduleTest
#	$(MAKE) moduleTest
#	./moduleTest

# distribution...

$(SDIST_STAMP) : $(BUILD_STAMP)
	./setup sdist

dist: $(DIST_STAMP)
$(DIST_STAMP) : $(HADDOCK_STAMP) $(USERGUIDE_STAMP) $(SDIST_STAMP)
	rm -rf $(DISTLOC)
	mkdir $(DISTLOC)
	tar -xzf $(SDIST_STAMP) -C $(DISTLOC)/
	mkdir $(DISTLOC)/Cabal-$(VERSION)/doc
	cp -r dist/doc/html $(DISTLOC)/Cabal-$(VERSION)/doc/API
	cp -r dist/doc/users-guide $(DISTLOC)/Cabal-$(VERSION)/doc/
	cp changelog $(DISTLOC)/Cabal-$(VERSION)/
	tar -C $(DISTLOC) -c Cabal-$(VERSION) -zf $(DISTLOC)/Cabal-$(VERSION).tar.gz
	mv $(DISTLOC)/Cabal-$(VERSION)/doc $(DISTLOC)/
	mv $(DISTLOC)/Cabal-$(VERSION)/changelog $(DISTLOC)/
	rm -r $(DISTLOC)/Cabal-$(VERSION)/
	@echo "Cabal tarball built: $(DIST_STAMP)"
	@echo "Release fileset prepared: $(DISTLOC)/"

release: $(DIST_STAMP)
	scp -r $(DISTLOC) haskell.org:/srv/web/haskell.org/cabal/release/cabal-$(VERSION)
	ssh haskell.org 'cd /srv/web/haskell.org/cabal/release && rm -f $(KIND) && ln -s cabal-$(VERSION) $(KIND)'

# tags...

TAGSSRCDIRS = Distribution Language
tags TAGS: $(SOURCES)
	find $(TAGSSRCDIRS) -name \*.\*hs | xargs hasktags

=== libraries/containers/benchmarks/Makefile ===
package := containers
version := $(shell awk '/^version:/{print $$2}' ../$(package).cabal)
lib := ../dist/build/libHS$(package)-$(version).a

programs := bench-Map bench-Set bench-IntMap bench-IntSet bench-Sequence
all: $(programs)
run: $(patsubst %, %.csv, $(programs))

bench-%: %.hs ../Data/%.hs
	ghc -DTESTING -cpp -O2 -fregs-graph -rtsopts --make -fforce-recomp -i.. -o $@ $<

bench-%.csv: bench-%
	./bench-$* -u bench-$*.csv +RTS -K10M

.PHONY: clean
clean:
	-find . \( -name '*.o' -o -name '*.hi' \) -exec rm {} \;
	-rm -f $(programs)

=== libraries/filepath/tests/Makefile ===
# This Makefile runs the tests using GHC's testsuite framework.  It
# assumes the package is part of a GHC build tree with the testsuite
# installed in ../../../testsuite.

TOP=../../../testsuite
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

.PHONY: ghc-filepath-tests
ghc-filepath-tests:
	$(RM) -f GenTests.hi GenTests.o GenTests
	$(RM) -f AutoTest.hi AutoTest.o
	$(RM) -f FilePath_Test.hi FilePath_Test.o FilePath_Test
	$(TEST_HC) -v0 --make GenTests
	./GenTests
	$(TEST_HC) -v0 --make FilePath_Test
	./FilePath_Test

=== libraries/time/test/Makefile ===
GHC = ghc
GHCFLAGS = -package time -package QuickCheck-1.2.0.1

default:
	make CurrentTime.run ShowDST.run test

TestMonthDay: TestMonthDay.o
	$(GHC) $(GHCFLAGS) $^ -o $@

ConvertBack: ConvertBack.o
	$(GHC) $(GHCFLAGS) $^ -o $@

TestCalendars: TestCalendars.o
	$(GHC) $(GHCFLAGS) $^ -o $@

TestTime: TestTime.o
	$(GHC) $(GHCFLAGS) $^ -o $@

LongWeekYears: LongWeekYears.o
	$(GHC) $(GHCFLAGS) $^ -o $@

ClipDates: ClipDates.o
	$(GHC) $(GHCFLAGS) $^ -o $@

AddDays: AddDays.o
	$(GHC) $(GHCFLAGS) $^ -o $@

TestFormat: TestFormat.o TestFormatStuff.o
	$(GHC) $(GHCFLAGS) $^ -o $@

TestFormatStuff.o: TestFormatStuff.c TestFormatStuff.h
	gcc -o $@ -c $<

TestParseDAT: TestParseDAT.o
	$(GHC) $(GHCFLAGS) $^ -o $@

TestEaster: TestEaster.o
	$(GHC) $(GHCFLAGS) $^ -o $@

CurrentTime: CurrentTime.o
	$(GHC) $(GHCFLAGS) $^ -o $@

ShowDST: ShowDST.o
	$(GHC) $(GHCFLAGS) $^ -o $@

TimeZone: TimeZone.o
	$(GHC) $(GHCFLAGS) $^ -o $@

TimeZone.ref: FORCE
	date +%z > $@

TestParseTime: TestParseTime.o
	$(GHC) $(GHCFLAGS) $^ -o $@

test:	\
	TestMonthDay.diff	\
	ConvertBack.diff0	\
	TestCalendars.diff	\
	TestTime.diff	\
	LongWeekYears.diff	\
	ClipDates.diff	\
	AddDays.diff	\
	TimeZone.diff	\
	TestFormat.diff0	\
	TestParseDAT.diff	\
	TestEaster.diff	\
	TestParseTime.run \
	UseCases.o
	@echo "Success!"

clean:
	rm -rf TestMonthDay ConvertBack TestCalendars TestTime LongWeekYears ClipDates	\
	AddDays TestFormat TestParseDAT TestEaster CurrentTime ShowDST TimeZone TimeZone.ref TestParseTime \
        *.out *.run *.o *.hi Makefile.bak

%.diff: %.ref %.out
	diff -u $^

%.diff0: %.out
	diff -u /dev/null $^

%.out: %
	./$< > $@

%.run: %
	./$<
	touch $@

%.hi: %.o
	@:

%.o: %.hs
	$(GHC) $(GHCFLAGS) -c $< -o $@

%.o: %.lhs
	$(GHC) $(GHCFLAGS) -c $< -o $@

FORCE:

.SECONDARY:

=== debian/changelog ===
ghc (7.4.1-4) unstable; urgency=low

  [ Erik de Castro Lopo ]
  * Add debian/patches/fix-PPC-right-shift-bug which fixes upstream GHC bug:
    http://hackage.haskell.org/trac/ghc/ticket/6156 (Closes: #677591)
  * Refresh other patches.
  * debian/contol: Add myself to uploaders and set DM-Upload-Allowed to yes.

  [ Joachim Breitner ]
  * debian/patches/no-useless-timer: Backported from GHC 7.4.2, (Closes:
    #677096)
  * Make sure GHC is using ld.bfd, as it passes arguments not understood by
    the gold linker (Closes: #673081) 
  * Use a saner priority for the runhaskell alternative. (Closes: #676970).
    TODO for later: Consider removing the alternatives code altogether.

 -- Joachim Breitner <nomeata@debian.org>  Sat, 16 Jun 2012 12:48:18 +0200

ghc (7.4.1-3) unstable; urgency=low

  * Remove the ghc-doc symlink logic from 7.0.4-3, as with 7.4.1, every
    documentation package had to be rebuit.
  * ghc-doc: Conflict on libghc-haddock-doc, as it contains files that moved
    into ghc-doc. (Closes: #659081)
  * Added debian/patches/memcpy-ffi.patch, backported from upstream master
    branch. See http://hackage.haskell.org/trac/ghc/ticket/5967.

 -- Joachim Breitner <nomeata@debian.org>  Sun, 06 May 2012 21:51:17 +0200

ghc (7.4.1-2) unstable; urgency=low

  [ Iain Lane ]

  * Two new patches (backported by Iulian Udrea) to fix armel build
    failures. See upstream bug #5824.
    - fix-ARM-s-StgCRun-clobbered-register-list-for-both-A
    - fix-ARM-StgCRun-to-not-save-and-restore-r11-fp-regis
  * Use dh_autoreconf{,_clean} to autoreconf, mainly so we can have proper
    clean support.
  * armhf support (thanks to Jani Monoses):
    - debian/patches/ARM-VFPv3D16: Use vfp3-d16 FPU for ARM builds.
    - debian/patches/armhf_llvm_abi: Pass -float-abi=hard to llc on armhf if
      __ARM_PCS_VFP is defined (needs to be preprocessed for this)
    - debian/rules: Define __ARM_PCS_VFP on armhf for the above patch.

  [ Joachim Breitner]

  * patches/hurd-is-ELF added, Closes: #659530, thanks to Samuel
    Thibault
  * Also conflict with any provided libghc-*-dev packages. Thus, if a packages
    is moved _into_ ghc that was outside before, no external package can be
    installed (as was the case with binary).
  * patches/no-missing-haddock-file-warning: Quench warning, as it is quite
    common on Debian installations.
  * build-depends-indep on hscolour and fop, to ensure most documentation is
    built.

 -- Joachim Breitner <nomeata@debian.org>  Sat, 10 Mar 2012 19:32:34 +0100

ghc (7.4.1-1) unstable; urgency=low

  * New upstream release.

 -- Joachim Breitner <nomeata@debian.org>  Fri, 03 Feb 2012 16:27:31 +0100

=== debian/control ===
Source: ghc
Section: haskell
Priority: extra
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Joachim Breitner <nomeata@debian.org>,
 Erik de Castro Lopo <erikd@mega-nerd.com>
DM-Upload-Allowed: yes
Standards-Version: 3.9.2
Build-Depends:
  debhelper (>= 7),
  libgmp-dev,
  devscripts,
  ghc,
  grep-dctrl,
  dh-autoreconf,
  gcc (>= 4:4.2),
  llvm-3.0 [armel armhf],
  libffi-dev,
  pkg-config,
  xsltproc,
  docbook-xsl,
  docbook-xml,
  binutils (>= 2.19.51.20090508) [arm armel],
  libncurses5-dev
Build-Depends-Indep:
  hscolour,
  fop
Build-Conflicts:
  ccache
Homepage: http://haskell.org/ghc/
Vcs-Darcs: http://darcs.debian.org/pkg-haskell/ghc
Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/ghc

Package: ghc
Architecture: any
Depends: gcc (>= 4:4.2), llvm-3.0 [armel armhf], libgmp-dev, libffi-dev, libbsd-dev, libc6-dev, ${shlibs:Depends}, ${misc:Depends}
Provides: haskell-compiler, ${provided-devs}, ${haskell:Provides}, ${ghci}
Replaces: ghc6 (<< 7)
Conflicts: ghc6 (<< 7), ${provided-devs}
Breaks: cabal-install (<< 0.8.0), haskell-devscripts (<< 0.6.19), ghc-doc (<= 6.12.1-8)
Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm-3.0
Description: The Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.

Package: ghc-prof
Architecture: any
Provides: ${provided-profs}, ${haskell:Provides}
Depends: ghc (= ${binary:Version}), ${misc:Depends}
Replaces: ghc6-prof (<< 7)
Conflicts: ghc6-prof (<< 7)
Description: Profiling libraries for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package contains additional profiling libraries. They are only needed,
 if you want to take a closer look on where exactly your program burns CPU
 cycles.

Package: ghc-doc
Section: doc
Architecture: all
Suggests: haskell-doc
Provides: ${provided-docs}
Replaces: ghc6-doc (<< 7), libghc-binary-doc
Conflicts: ghc6-doc (<< 7), ghc (<= 7.0.3-1), libghc-binary-doc
Depends: ${haddock:Depends}, ${misc:Depends}, perl
Description: Documentation for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package includes HTML, DVI and PS versions of the SGML-based
 documentation around GHC.

Package: ghc-dynamic
Architecture: i386 amd64
Depends: ghc (= ${binary:Version}), ${misc:Depends}
Description: Dynamic libraries for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package has dynamically linkable, shared versions of the
 libraries included with GHC.  Currently, they are available only on
 i386 and amd64 architectures.

Package: ghc-haddock
Architecture: any
Provides: haddock, ${haddock:Provides}
Conflicts: haddock
Depends: ghc (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Homepage: http://www.haskell.org/haddock/
Description: Documentation tool for annotated Haskell source code
 Haddock is a tool for automatically generating documentation from
 annotated Haskell source code.  It is primary intended for documenting
 libraries, but it should be useful for any kind of Haskell code.
 .
 Haddock lets you write documentation annotations next to the
 definitions of functions and types in the source code, in a syntax
 that is easy on the eye when writing the source code (no heavyweight
 mark-up).  The documentation generated by Haddock is fully hyperlinked:
 click on a type name in a type signature to go straight to the
 definition, and documentation, for that type.
 .
 Haddock can generate documentation in multiple formats; currently HTML
 is implemented, and there is partial support for generating DocBook.
 .
 This package contains Haddock version 2.10.0.

Package: ghc6
Architecture: all
Depends: ghc, ${misc:Depends}
Description: transitional dummy package
 This package ensures a smooth transition from the package name ghc6 to the
 package name ghc, and can safely be removed.

Package: ghc6-doc
Architecture: all
Depends: ghc-doc, ${misc:Depends}
Section: doc
Description: transitional dummy package
 This package ensures a smooth transition from the package name ghc6-doc to the
 package name ghc-doc, and can safely be removed.

Package: ghc6-prof
Architecture: all
Depends: ghc-prof, ${misc:Depends}
Description: transitional dummy package
 This package ensures a smooth transition from the package name ghc6-prof to the
 package name ghc-prof, and can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# This file is public domain software, originally written by Joey Hess.
#
# This version is for a multibinary package. It also allows you to build any
# of the binary packages independantly, via binary-<package> targets.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# Set a dummy HOME variable upon build. Some build daemons do not set HOME, but
# ghc-cabal expects it to be available.
export HOME = /homedoesnotexistatbuildtime

# From /usr/share/doc/autotools-dev/examples/rules.gz:
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
# Commented out for now.  The build scripts don't recognise i486 as an
# architecture and cross compiling isn't supported anyway.
#ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
#  confflags += --build $(DEB_HOST_GNU_TYPE)
#else
#  confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
#endif

ProjectVersion=$(shell cat VERSION)

GHC=$(firstword $(shell bash -c "type -p ghc"))
EXTRA_CONFIGURE_FLAGS=--with-ghc="$(GHC)"
BUILD_HADDOCK_DOCS=YES

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	dh_autoreconf

	rm -f mk/build.mk
	echo "SRC_HC_OPTS += -lffi -optl-pthread" >> mk/build.mk
	echo "HADDOCK_DOCS := YES" >> mk/build.mk
	echo "XSLTPROC_OPTS += --nonet" >> mk/build.mk
ifneq (,$(findstring $(DEB_HOST_ARCH), arm armel armhf))
	echo "SRC_HC_OPTS     += -optc-mlong-calls" >> mk/build.mk
endif
ifeq (armhf,$(DEB_HOST_ARCH))
	echo "SRC_HC_OPTS += -D__ARM_PCS_VFP" >> mk/build.mk
endif
# proper fix for #360177
ifeq (ppc64,$(DEB_HOST_ARCH))
	echo "SRC_HC_OPTS += -optc-mminimal-toc" >> mk/build.mk
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
#	echo "GhcStage1HcOpts += -DDEBUG" >> mk/build.mk
#	echo "GhcStage2HcOpts += -DDEBUG" >> mk/build.mk
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -Rghc-timing -DDEBUG" >> mk/build.mk
#	echo "GhcLibHcOpts  += -O -dcore-lint -keep-hc-files " >> mk/build.mk
	echo "SplitObjs     = NO" >> mk/build.mk
	echo "STRIP         = :" >> mk/build.mk
endif
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -O0" >> mk/build.mk
	# This breaks the build - to be investigated:
	# echo "GhcLibHcOpts  += -O0" >> mk/build.mk
	echo "GhcRtsCcOpts  += -O0" >> mk/build.mk
endif
	# We can't do this with a configure flag in 6.8.1 as libdir is not
	# defined at the point at which we := it
	echo 'ghclibdir := $${libdir}/ghc' >> mk/build.mk
	echo 'bindir  := $${ghclibdir}/bin' >> mk/build.mk
	echo 'ghclibexecdir := $${ghclibdir}/lib' >> mk/build.mk
	# docdir doesn't have a configure flag, and unfortunately
	# we also need to explicitly define all of its dependents as they
	# are set with :=
	echo 'docdir  := $$(datarootdir)/doc/ghc-doc' >> mk/build.mk
	echo 'htmldir := $$(docdir)'                   >> mk/build.mk
	echo 'dvidir  := $$(docdir)'                   >> mk/build.mk
	echo 'pdfdir  := $$(docdir)'                   >> mk/build.mk
	echo 'psdir   := $$(docdir)'                   >> mk/build.mk
	rm -f config.sub
	rm -f config.guess
	ln -s /usr/share/misc/config.sub .
	ln -s /usr/share/misc/config.guess .
	./configure $(confflags) --prefix=/usr \
		$(EXTRA_CONFIGURE_FLAGS) \
		--with-ld=ld.bfd

	touch $@

build: build-stamp
build-stamp: configure-stamp
	dh_testdir
	$(MAKE) $(MAKEFLAGS)

	# Do some very simple tests that the compiler actually works
	rm -rf debian/testghc
	mkdir debian/testghc
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo -O2
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*

# build haddock separately and hard code paths according to install paths
	mkdir -p debian/haddock-build
	cp -r utils/haddock debian/haddock-build
	cd debian/haddock-build/haddock; \
	        rm -rf dist; \
		../../../inplace/bin/ghc-stage2 --make Setup.lhs; \
		./Setup configure --prefix=/usr --with-compiler=../../../inplace/bin/ghc-stage2 \
			--package-db=../../../inplace/lib/package.conf.d/ \
			--htmldir=/usr/share/doc/ghc-haddock/html/ ; \
		./Setup build

	touch $@

FILES = \( -type f -o -type l \)
PROF_FILE = \( -name "*.p_*" -o -name "lib*_p.a" \)
DYNAMIC_FILE = \( -name "*.dyn_hi" -o -name lib*.so \)

install: install-stamp
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_prep

	# Install the basic stuff
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install

	# Delete all the library LICENSE files
	rm -f debian/tmp/usr/share/doc/ghc-doc/html/libraries/*/LICENSE

	# Generate lintian overrides
	mkdir -p debian/tmp/usr/share/lintian/overrides
	echo "ghc binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
	echo "ghc: extra-license-file `cl debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.dyn_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
	echo "ghc-prof binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.p_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc-prof

	# Sort out the package.conf files
	mkdir -p debian/tmp/var/lib/ghc
	# Old directories for symlink-workaround. Remove once all libraries use new path
	mv debian/tmp/usr/lib/ghc/package.conf.d \
	   debian/tmp/var/lib/ghc/
	rm debian/tmp/var/lib/ghc/package.conf.d/package.cache
	chmod +x debian/provided_substvars
	debian/provided_substvars
	sed -ri 's,^haddock-interfaces: /.*?/libraries/,haddock-interfaces: /usr/lib/ghc-doc/haddock/,' debian/tmp/var/lib/ghc/package.conf.d/*.conf

	# Remove haddock as built within the ghc tree
	rm -f debian/tmp/usr/lib/ghc/bin/haddock \
	      debian/tmp/usr/lib/ghc/bin/haddock-$(ProjectVersion) \
	      debian/tmp/usr/lib/ghc/lib/haddock
	rm -rf debian/tmp/usr/lib/ghc/html

	# Sort out the binaries
	mkdir -p debian/tmp/usr/bin
	if inplace/bin/ghc-stage2 --info | grep '"Have interpreter","NO"'; then \
	    cd debian/tmp/usr/lib/ghc ;rm -f bin/ghci* bin/runghc* bin/runhaskell*; \
	fi
	cd debian/tmp/usr/lib/ghc/bin && \
	    for f in *; \
	    do ln -s /usr/lib/ghc/bin/$$f \
	             ../../../bin/$${f}; \
	    done
	sed -i 's,topdir="/usr/lib,topdir="/var/lib,' debian/tmp/usr/lib/ghc/bin/ghc-pkg-$(ProjectVersion)
	cd debian/haddock-build/haddock; ./Setup copy --dest=../../tmp

	# Check if we have a ghci binary
	if test -e debian/tmp/usr/lib/ghc/bin/ghci-$(ProjectVersion); then \
	    echo 'ghci=ghc-ghci' >> debian/ghc.substvars ; fi

	# Add haddock substvars
	echo "haddock:Depends=haddock-interface-$$(debian/tmp/usr/bin/haddock --interface-version)" >> debian/ghc-doc.substvars
	echo "haddock:Provides=haddock-interface-$$(debian/tmp/usr/bin/haddock --interface-version)" >> debian/ghc-haddock.substvars

ifeq (YES,$(BUILD_HADDOCK_DOCS))
	mkdir -p debian/tmp/usr/lib/ghc-doc
	cp debian/gen_contents_index debian/tmp/usr/lib/ghc-doc/
	chmod +x debian/tmp/usr/lib/ghc-doc/gen_contents_index
	mkdir debian/tmp/usr/lib/ghc-doc/haddock/
	for f in `find debian/tmp/usr/share/doc/ghc-doc/html/libraries/ -maxdepth 1 -mindepth 1 -type d`; do \
	    mkdir debian/tmp/usr/lib/ghc-doc/haddock/`basename $$f` ; \
	    mv $$f/*.haddock debian/tmp/usr/lib/ghc-doc/haddock/`basename $$f` ; done
	cd debian/tmp/usr/share/doc/ghc-doc/html/libraries/; ln -s ghc-$(ProjectVersion) ghc
	install -Dm 644 debian/index.html debian/tmp/usr/share/doc/ghc-doc/index.html
endif

## ghc 7.4.2

=== debian/changelog ===
ghc (7.4.2-2) experimental; urgency=low

  [ Erik de Castro Lopo ]
  * Add patch to fix GHCi segfault on startup on PowerPC (Closes: #631073).
  * Remove patch no_ghci_on_powerpc.

  [ Iain Lane ]
  * Update Vcs-* to point to experimental branch

 -- Erik de Castro Lopo <erikd@mega-nerd.com>  Mon,  6 Aug 2012 20:19:46 +1000

ghc (7.4.2-1) experimental; urgency=low

  * New upstream.
  * debian/patches/series
    - Remove patch fix-ARM-s-StgCRun-clobbered-register-list-for-both-A,
      fix-ARM-StgCRun-to-not-save-and-restore-r11-fp-regis and memcpy-ffi.patch
      (in upstream).
    - Refresh other patches.

 -- Erik de Castro Lopo <erikd@mega-nerd.com>  Mon, 11 Jun 2012 15:21:26 +1000

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,7 @@
 Section: haskell
 Priority: extra
 Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
-Uploaders: Joachim Breitner <nomeata@debian.org>,
- Erik de Castro Lopo <erikd@mega-nerd.com>
-DM-Upload-Allowed: yes
+Uploaders: Joachim Breitner <nomeata@debian.org>
 Standards-Version: 3.9.2
 Build-Depends:
   debhelper (>= 7),
@@ -28,8 +26,8 @@
 Build-Conflicts:
   ccache
 Homepage: http://haskell.org/ghc/
-Vcs-Darcs: http://darcs.debian.org/pkg-haskell/ghc
-Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/ghc
+Vcs-Darcs: http://darcs.debian.org/pkg-haskell/experimental/ghc
+Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/experimental/ghc
 
 Package: ghc
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -88,9 +88,7 @@
 	rm -f config.guess
 	ln -s /usr/share/misc/config.sub .
 	ln -s /usr/share/misc/config.guess .
-	./configure $(confflags) --prefix=/usr \
-		$(EXTRA_CONFIGURE_FLAGS) \
-		--with-ld=ld.bfd
+	./configure $(confflags) --prefix=/usr $(EXTRA_CONFIGURE_FLAGS)
 
 	touch $@

=== debian/watch ===
version=3
http://haskell.org/ghc/dist/([\d.]+)/ghc-([\d.]+)-src.tar.bz2

## ghc 7.6.2

=== debian/changelog ===
ghc (7.6.2-1ubuntu1) raring; urgency=low

  * Disable GHCi on armhf for now; it is too badly broken.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 11 Apr 2013 10:22:33 +0100

ghc (7.6.2-1) experimental; urgency=low

  * New upstream release

 -- Joachim Breitner <nomeata@debian.org>  Tue, 29 Jan 2013 21:16:52 +0100

ghc (7.6.1.20121207-2) experimental; urgency=low

  * Typo in ghc-haddock’s Provides, thanks to David Fox for noticing. 

 -- Joachim Breitner <nomeata@debian.org>  Thu, 13 Dec 2012 18:33:48 +0100

ghc (7.6.1.20121207-1) experimental; urgency=low

  * New upstream release (aka 7.6.1-rc).
    + Closes: #677096 (huge number of wakeups)
  * Remove debian/patches/armhf_llvm_abi, applied upstream, thanks to Shawn
    Landden for noticing (Closes: #695739)
  * Hardcode in debian/rules that haddock supportin interface version 22 also
    supports interface version 21.

 -- Joachim Breitner <nomeata@debian.org>  Wed, 12 Dec 2012 12:32:48 +0100

ghc (7.6.1-3) experimental; urgency=low

  * Bump standards version, no change
  * Change VCS fields back to regular repo 
  * Build the runtime also in the thr_debug_p way, suggestion by Michał J.
    Gajda

 -- Joachim Breitner <nomeata@debian.org>  Tue, 04 Dec 2012 22:00:27 +0100

ghc (7.6.1-2) experimental; urgency=low

  * Do not Provide transformers, it is only used internally.
  * Ensure this is not used with unstable’s haskell-devscripts 

 -- Joachim Breitner <nomeata@debian.org>  Mon, 08 Oct 2012 22:41:46 +0200

ghc (7.6.1-1) experimental; urgency=low

  * New upstream release 
    Dropped patches, applied upstream:
     + Fix-GHCi-segfault-on-linux-powerpc
     + hurd-is-ELF
     + use-llvm-3.0
     + memcpy-ffi
     + fix-PPC-right-shift-bug
     + no-useless-time
     + fix-ppc-ghci-segfault
  * Configure the use of llc-3.0 and opt-3.0 via ./configure 
  * Bump standards version

 -- Joachim Breitner <nomeata@debian.org>  Mon, 08 Oct 2012 15:48:21 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,12 @@
 Source: ghc
 Section: haskell
 Priority: extra
-Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
-Uploaders: Joachim Breitner <nomeata@debian.org>
-Standards-Version: 3.9.2
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
+Uploaders: Joachim Breitner <nomeata@debian.org>,
+ Erik de Castro Lopo <erikd@mega-nerd.com>
+DM-Upload-Allowed: yes
+Standards-Version: 3.9.4
 Build-Depends:
   debhelper (>= 7),
   libgmp-dev,
@@ -26,8 +29,8 @@
 Build-Conflicts:
   ccache
 Homepage: http://haskell.org/ghc/
-Vcs-Darcs: http://darcs.debian.org/pkg-haskell/experimental/ghc
-Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/experimental/ghc
+Vcs-Darcs: http://darcs.debian.org/pkg-haskell/ghc
+Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/ghc
 
 Package: ghc
 Architecture: any
@@ -35,7 +38,7 @@
 Provides: haskell-compiler, ${provided-devs}, ${haskell:Provides}, ${ghci}
 Replaces: ghc6 (<< 7)
 Conflicts: ghc6 (<< 7), ${provided-devs}
-Breaks: cabal-install (<< 0.8.0), haskell-devscripts (<< 0.6.19), ghc-doc (<= 6.12.1-8)
+Breaks: cabal-install (<< 0.8.0), haskell-devscripts (<< 0.8.13), ghc-doc (<= 6.12.1-8)
 Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm-3.0
 Description: The Glasgow Haskell Compilation system
  The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for

=== debian/rules ===
--- 
+++ 
@@ -30,6 +30,7 @@
 GHC=$(firstword $(shell bash -c "type -p ghc"))
 EXTRA_CONFIGURE_FLAGS=--with-ghc="$(GHC)"
 BUILD_HADDOCK_DOCS=YES
+DEB_HOOGLE_TXT_DIR = /usr/lib/ghc-doc/hoogle/
 
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
     NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
@@ -71,6 +72,15 @@
 	# echo "GhcLibHcOpts  += -O0" >> mk/build.mk
 	echo "GhcRtsCcOpts  += -O0" >> mk/build.mk
 endif
+	# We also want to build the threaded profiling-enabled debug runtime,
+	# because it does no harm
+	echo 'GhcRTSWays += $$(if $$(findstring p, $$(GhcLibWays)),thr_debug_p,)' >> mk/build.mk
+ifneq (,$(findstring $(DEB_HOST_ARCH),armel armhf))
+	# GHCi is too badly broken on ARM; see
+	# http://hackage.haskell.org/trac/ghc/ticket/7794
+	echo "GhcWithInterpreter = NO" >> mk/build.mk
+endif
+	
 	# We can't do this with a configure flag in 6.8.1 as libdir is not
 	# defined at the point at which we := it
 	echo 'ghclibdir := $${libdir}/ghc' >> mk/build.mk
@@ -88,7 +98,11 @@
 	rm -f config.guess
 	ln -s /usr/share/misc/config.sub .
 	ln -s /usr/share/misc/config.guess .
-	./configure $(confflags) --prefix=/usr $(EXTRA_CONFIGURE_FLAGS)
+	./configure $(confflags) --prefix=/usr \
+		$(EXTRA_CONFIGURE_FLAGS) \
+		--with-ld=ld.bfd \
+		--with-llc=llc-3.0 \
+		--with-opt=opt-3.0
 
 	touch $@
 
@@ -179,17 +193,7 @@
 
 	# Add haddock substvars
 	echo "haddock:Depends=haddock-interface-$$(debian/tmp/usr/bin/haddock --interface-version)" >> debian/ghc-doc.substvars
-	echo "haddock:Provides=haddock-interface-$$(debian/tmp/usr/bin/haddock --interface-version)" >> debian/ghc-haddock.substvars
-
-ifeq (YES,$(BUILD_HADDOCK_DOCS))
-	mkdir -p debian/tmp/usr/lib/ghc-doc
-	cp debian/gen_contents_index debian/tmp/usr/lib/ghc-doc/
-	chmod +x debian/tmp/usr/lib/ghc-doc/gen_contents_index
-	mkdir debian/tmp/usr/lib/ghc-doc/haddock/
-	for f in `find debian/tmp/usr/share/doc/ghc-doc/html/libraries/ -maxdepth 1 -mindepth 1 -type d`; do \
-	    mkdir debian/tmp/usr/lib/ghc-doc/haddock/`basename $$f` ; \
-	    mv $$f/*.haddock debian/tmp/usr/lib/ghc-doc/haddock/`basename $$f` ; done
-	cd debian/tmp/usr/share/doc/ghc-doc/html/libraries/; ln -s ghc-$(ProjectVersion) ghc
-	install -Dm 644 debian/index.html debian/tmp/usr/share/doc/ghc-doc/index.html
-endif
-
+	# Hardcode that 22 supports 21, until http://trac.haskell.org/haddock/ticket/231 is fixed
+	if [ $$(debian/tmp/usr/bin/haddock --interface-version) -eq 22 ] ; then \
+	    echo "haddock:Provides=haddock-interface-21, haddock-interface-22" >> debian/ghc-haddock.substvars; \
+	    else \
